/* legge dall'input un numero n, poi alloca spazio per esattamente n parole.
Ogni parola, di lunghezza massima DIMWORD, e' allocata nello spazio minimo
necessario a memorizzarla correttamente */

#include <stdio.h>
#include <stdlib.h>  /* per utilizzare malloc, calloc e free */
#include <string.h>  /* per utilizzare strlen, strcpy */

#define DIMWORD	80

int main(void)
{
	char **words;
	char w[DIMWORD+1];
	int i,n;

	scanf("%d",&n);
	if(!(words = calloc(n,sizeof(char *)))) {
		fprintf(stderr,"Errore di allocazione per l'array \"words\"\n");
		return -1;
	}
	for(i = 0; i < n;i++) {
		scanf("%s",w);
		if(!(words[i] = malloc(strlen(w)+1))) {
			fprintf(stderr,"Errore di allocazione per la parola \"%s\"\n",w);
			return -2;
		}
		strcpy(words[i],w);		
	}
	printf("Elenco delle parole lette:\n");
	for(i = 0; i < n;i++) {
		printf("%d) %s\n",i+1,words[i]);
		free(words[i]);
	}
	free(words);
	printf("Fine dell'elenco.\n");
	return 0;
}
