#include <stdio.h>
#include <stdlib.h>

/*
#define DEBUG 
*/

void mergesort(int *a, int *b, int l, int r)
{
	int i,j,k,m;

#ifdef DEBUG
	for(i = 0; i < l; i++) printf("    ");
	for(i = l; i <= r; i++) printf("%3d ",a[i]);
	putchar('\n');
#endif

	if(r > l) {
		m = (r+l)/2;
		mergesort(a,b,l,m);		
		mergesort(a,b,m+1,r);
		for(i = m+1; i > l; i--)
			b[i-1] = a[i-1];
		for(j = m; j < r; j++)
			b[r+m-j] = a[j+1];
		for(k = l; k <= r; k++)
			a[k] = b[i] < b[j] ? b[i++] : b[j--];
	}

#ifdef DEBUG	
	for(i = 0; i < l; i++) printf("    ");
	for(i = l; i <= r; i++) printf("---%c",i == m ? '|' : '-');
	putchar('\n');
	for(i = 0; i < l; i++) printf("    ");
	for(i = l; i <= r; i++) printf("%3d ",a[i]);
	putchar('\n');
#endif

}

void ordina(int *a, int l, int r)
{
	int *b = calloc(r - l + 1, sizeof(int));
	
	if(!b) {
      		fprintf(stderr,"Errore di allocazione\n");
      		exit(-1);
    	}
	mergesort(a,b,l,r);
	free(b);
}

#define MAXSIZE 100

int main(void)
{
	int i,a[MAXSIZE];
	int j = 0;

	do
		printf("Immetti numero:\n");
	while(scanf("%d",a + j++));
	
	j--;
	printf("Array da ordinare:");
	for(i = 0; i < j; i++) printf("%d ",a[i]);
	putchar('\n');

	ordina(a,0,j-1);

	printf("\nArray ordinato:");
	for(i = 0; i < j; i++) printf("%d ",a[i]);
}
