#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define BUFFERSIZE 512
#define BLOCKSIZE 10

char *leggiparola(FILE *fp)
{
	static char buf[BUFFERSIZE];
	char *s = buf;
	char *t;
	int c;

	while((c = fgetc(fp)) != EOF && !isalnum(*s = c));
	if(c != EOF)
		while(isalnum(*++s = fgetc(fp)));
	*s = 0;
	t = malloc(strlen(buf)+1);
	return strlen(buf) ? strcpy(t,buf) : NULL;
}

char **leggitesto(FILE *fp,int *pn)
{
	char **words = malloc(BLOCKSIZE * sizeof(char *));
	char *s;

	*pn = 0;
	while((s = leggiparola(fp)) && strcmp("END",s) != 0) {
		words[(*pn)++] = s;
		if(!(*pn % BLOCKSIZE))
			words = realloc(words,(*pn/BLOCKSIZE + 1) * BLOCKSIZE * sizeof(char *));
	}
	return words;
}

void mergesort(char **a, char **b, int l, int r)
{
	int i,j,k,m;

	if(r > l) {
		m = (r+l)/2;
		mergesort(a,b,l,m);		
		mergesort(a,b,m+1,r);
		for(i = m+1; i > l; i--)
			b[i-1] = a[i-1];
		for(j = m; j < r; j++)
			b[r+m-j] = a[j+1];
		for(k = l; k <= r; k++)
			a[k] = strcmp(b[i],b[j]) < 0 ? b[i++] : b[j--];
	}
}

int main(void)
{
	int i,n;
	char **w = leggitesto(stdin,&n);
	char **b = calloc(n, sizeof(char *));
		
	mergesort(w,b,0,n-1);
	for(i = 0;i < n;i++)
		printf("%s\n",w[i]);	
}
